import { buildUUID } from '../../../utils/uuid';
import { ApiActionPage } from '../../model/baseModel';
import {
  RegionListItem,
  RegionPageParams,
  RegionPageListGetResultModel,
} from '../model/warehoueseModel';
import { genAction, Api, genActionPage } from '../system';
import { defHttp } from '/@/utils/http/axios';

/*
 * 获取区域分页列表
 */
export const getRegionListByPage = async (params: RegionPageParams) => {
  let sqlcmd = '';
  if (params?.REGION_CODE != undefined && params?.REGION_CODE != '') {
    sqlcmd += "And REGION_CODE like '%" + params?.REGION_CODE + "%'";
  }
  if (params?.REGION_NAME != undefined && params?.REGION_NAME != '') {
    sqlcmd += "And REGION_NAME = '" + params?.REGION_NAME + "'";
  }
  const rParams = genActionPage('WMS_REGION', sqlcmd, params.page, params.pageSize);
  return getRegionListByPageAsync(rParams);
};
async function getRegionListByPageAsync(params: ApiActionPage) {
  const data = await defHttp.post<ApiActionPage>(
    { url: Api.EntityPageList, params },
    {
      isTransformResponse: false,
    },
  );
  const model: RegionPageListGetResultModel = {
    items: data.Data.data,
    total: data.Data.totals,
  };
  return model;
}

export const SaveRegion = async (params: RegionListItem, isUpdate: boolean) => {
  let data;
  if (isUpdate) {
    data = await defHttp.post(
      { url: Api.UpdateEntity, params: genAction('WMS_REGION', params) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
      },
    );
  } else {
    params.ID = buildUUID(); //生成GUID
    data = await defHttp.post(
      { url: Api.AddEntity, params: genAction('WMS_REGION', params) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
      },
    );
  }
  return data;
};

export const DeleteRegion = async (params: Recordable) => {
  const usParams = genAction('WMS_REGION', [params]);
  return await defHttp.post(
    { url: Api.DeleteList, params: usParams },
    {
      errorMessageMode: 'none',
      isTransformResponse: false,
    },
  );
};